class GridTile {
    // x, y of top left corner
    constructor(x, y, size, type, orientation) {
      this.size = size;
      this.x = x;
      this.y = y;
      this.selected = false;
    //   this.spriteImage = spriteImage;  // The image that's shown
      this.item = null;

      // TODO: consider moving to the preload function to avoid overhead
      // or make these global??
      this.roadImg = loadImage('assets/road.png');  // (0) road
      this.cityImg = loadImage('assets/grass.png');  // (1) city
      this.roadSidewalkVerticalImg = loadImage("assets/road_vert_sidewalk.png");  // (2) road with sidewalk (vertical) 
      this.roadSidewalkHorizontalImg = loadImage("assets/road_horiz_sidewalk.png");  // (3) road with sidewalk (horizontal)
      this.roadSidewalk_4WayImg = loadImage("assets/road_4way_intersection.png");  // (4) road with sidewalk (4-way intersection)
      // roadSidewalk_3WayBlockedLeftImg = laodImage("road_3wayLeft_sidewalk.png");  // (5) road with sidewalk (3-way intersection no left)
      // roadSidewalk_3WayBlockedRightImg = laodImage("road_3wayRight_sidewalk.png");  // (6) road with sidewalk (3-way intersection no right)
      // roadBusStopVerticalImg = laodImage("road_vert_bus.png");  // (7) road with bus stop (vertical)
      // roadBusStopHorizontalImg = laodImage("road_horizontal_bus.png");  // (8) road with bus stop (horizontal)
      // roadSidewalkVertical_BrokenImg = laodImage("road_vert_broken_sidewalk.png");  // (9) road with broken sidwalk (vertical)
      // roadSidewalkHorizontal_BrokenImg = laodImage("road_horiz_broken_sidewalk.png");  // (10) road with broken sidwalk (horizontal)

      // Orientation can either be:
      //    
      /* Orientation can either be
        - vertical
        - horizontal
        - 4way (for sidewalk piece) 
        - TopRightCorner (not in current version)
        - TopLeftCorner (not in current version)
        - BotRighttCorner (not in current version)
        - TopRightCorner (not in current version)
      */
     // For sidewalk pieces, helps decide which sprite/image to use when changing types
      this.orientation = orientation;

      /* Tells us what point type this tile has. Is either
        - road (no points)
        - city (no points and you can't switch types)
        - sidewalk (medium cost & time)
        - sidewalk with bus stop (high cost and )
      */
      this.type = type;
    }
    
    placeObject(img) {
      this.item = img;
    }
    
    draw() {
      imageMode(CORNER);
      if (this.type === 'road') {
        image(this.roadImg, this.x, this.y, this.size, this.size);
      } else if (this.type === "sidewalk") {
        // Check to see which orientation this road tile is in so that we
        // place the correctly oriented sidewalk piece
        if (this.orientation === "vertical") {
            image(this.roadSidewalkVerticalImg, this.x, this.y, this.size, this.size);
        } else if (this.orientation === "horizontal") {
            image(this.roadSidewalkHorizontalImg, this.x, this.y, this.size, this.size);
        } else if (this.orientation === "4way") {
            image(this.roadSidewalk_4WayImg, this.x, this.y, this.size, this.size);
        }
      } else {
        // By default, this is a city piece
        // i.e. this.type == "city" or anything else
        image(this.cityImg, this.x, this.y, this.size, this.size);
      }
    //   else if (this.type == "busStop") {
    //     // Check to see which orientation this road tile is in so that we
    //     // place the correctly oriented sidewalk piece
    //     if (this.orientation == "vertical") {
    //         image(this.roadSidewalkVerticalImg, this.x, this.y, this.size, this.size);
    //     } else if (this.orientation == "horizontal") {
    //         image(this.roadSidewalkHorizontalImg, this.x, this.y, this.size, this.size);
    //     } else if (this.orientation == "4way") {
    //         image(this.roadSidewalk_4WayImg, this.x, this.y, this.size, this.size);
    //     }
    //   }
      if (this.item != null) {
        // TOOD: remove this, I dont' think we'll need it?
        imageMode(CENTER);
        image(this.item, this.x + this.size / 2, this.y + this.size / 2, 
              this.size * 3/4, this.size * 3/4);
      }
    }
    
    addItem(item) {
      this.item = item;
    }
    
    switchType(newType) {
        console.log(`The new type that was passed was: ${newType}`)
        // The player can change any road type except city road types
        if (this.type !== "city") {
            this.type = newType;
            this.item = null;  // TODO: Get rid of
        }
    }
    
    highlight() {
      this.selected = true;
      stroke(46, 100, 85);
      strokeWeight(4);
      noFill();
      square(this.x, this.y, this.size);
    }
  }